Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.scheduling.commonj
Class TimerManagerFactoryBean

    java.lang.Object
      org.springframework.jndi.JndiAccessor
          org.springframework.jndi.JndiLocatorSupport
              org.springframework.scheduling.commonj.TimerManagerFactoryBean

All Implemented Interfaces:
  DisposableBean, FactoryBean, InitializingBean, Lifecycle

    public class TimerManagerFactoryBean

extends JndiLocatorSupport
implements FactoryBean, InitializingBean, DisposableBean, Lifecycle

`FactoryBean` that retrieves a CommonJ `TimerManager` and exposes it for bean references.

This is the central convenience class for setting up a CommonJ TimerManager in a Spring context.

Allows for registration of ScheduledTimerListeners. This is the main purpose of this class; the TimerManager itself could also be fetched from JNDI via `JndiObjectFactoryBean`. In scenarios that just require static registration of tasks at startup, there is no need to access the TimerManager itself in application code.

Note that the TimerManager uses a TimerListener instance that is shared between repeated executions, in contrast to Quartz which instantiates a new Job for each execution.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  `ScheduledTimerListener`, `TimerManager`, `TimerListener`

Field Summary

Fields inherited from class org.springframework.jndi.JndiLocatorSupport
`CONTAINER_PREFIX`

Fields inherited from class org.springframework.jndi.JndiAccessor
`logger`

Constructor Summary
`TimerManagerFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`void` | `destroy()` Cancels all statically registered Timers on shutdown, and stops the underlying TimerManager (if not shared).
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isRunning()` Considers the underlying TimerManager as running if it is neither suspending nor stopping.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`void` | `setScheduledTimerListeners(ScheduledTimerListener[] scheduledTimerListeners)` Register a list of ScheduledTimerListener objects with the TimerManager that this FactoryBean creates.
`void` | `setShared(boolean shared)` Specify whether the TimerManager obtained by this FactoryBean is a shared instance ("true") or an independent instance ("false").
`void` | `setTimerManager(commonj.timers.TimerManager timerManager)` Specify the CommonJ TimerManager to delegate to.
`void` | `setTimerManagerName(String timerManagerName)` Set the JNDI name of the CommonJ TimerManager.
`void` | `start()` Resumes the underlying TimerManager (if not shared).
`void` | `stop()` Suspends the underlying TimerManager (if not shared).

Methods inherited from class org.springframework.jndi.JndiLocatorSupport
`convertJndiName, isResourceRef, lookup, lookup, setResourceRef`

Methods inherited from class org.springframework.jndi.JndiAccessor
`getJndiEnvironment, getJndiTemplate, setJndiEnvironment, setJndiTemplate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TimerManagerFactoryBean

    public TimerManagerFactoryBean()

Method Detail

### setTimerManager

    public void setTimerManager(commonj.timers.TimerManager timerManager)

  Specify the CommonJ TimerManager to delegate to.

  Note that the given TimerManager's lifecycle will be managed by this FactoryBean.

  Alternatively (and typically), you can specify the JNDI name of the target TimerManager.

  See Also:
    `setTimerManagerName(java.lang.String)`

### setTimerManagerName

    public void setTimerManagerName(String timerManagerName)

  Set the JNDI name of the CommonJ TimerManager.

  This can either be a fully qualified JNDI name, or the JNDI name relative to the current environment naming context if "resourceRef" is set to "true".

  See Also:
    `setTimerManager(commonj.timers.TimerManager)`, `JndiLocatorSupport.setResourceRef(boolean)`

### setShared

    public void setShared(boolean shared)

  Specify whether the TimerManager obtained by this FactoryBean is a shared instance ("true") or an independent instance ("false"). The lifecycle of the former is supposed to be managed by the application server, while the lifecycle of the latter is up to the application.

  Default is "false", i.e. managing an independent TimerManager instance. This is what the CommonJ specification suggests that application servers are supposed to offer via JNDI lookups, typically declared as a `resource-ref` of type `commonj.timers.TimerManager` in `web.xml`, with `res-sharing-scope` set to 'Unshareable'.``

  Switch this flag to "true" if you are obtaining a shared TimerManager, typically through specifying the JNDI location of a TimerManager that has been explicitly declared as 'Shareable'. Note that WebLogic's cluster-aware Job Scheduler is a shared TimerManager too.

  The sole difference between this FactoryBean being in shared or non-shared mode is that it will only attempt to suspend / resume / stop the underlying TimerManager in case of an independent (non-shared) instance. This only affects the `Lifecycle` support as well as application context shutdown.

  See Also:
    `stop()`, `start()`, `destroy()`, `TimerManager`

### setScheduledTimerListeners

    public void setScheduledTimerListeners(ScheduledTimerListener[] scheduledTimerListeners)

  Register a list of ScheduledTimerListener objects with the TimerManager that this FactoryBean creates. Depending on each ScheduledTimerListener's settings, it will be registered via one of TimerManager's schedule methods.

  See Also:
    `TimerManager.schedule(commonj.timers.TimerListener, long)`, `TimerManager.schedule(commonj.timers.TimerListener, long, long)`, `TimerManager.scheduleAtFixedRate(commonj.timers.TimerListener, long, long)`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws NamingException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `NamingException`

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### start

    public void start()

  Resumes the underlying TimerManager (if not shared).

  Specified by:
    `start` in interface `Lifecycle`
  See Also:
    `TimerManager.resume()`

### stop

    public void stop()

  Suspends the underlying TimerManager (if not shared).

  Specified by:
    `stop` in interface `Lifecycle`
  See Also:
    `TimerManager.suspend()`

### isRunning

    public boolean isRunning()

  Considers the underlying TimerManager as running if it is neither suspending nor stopping.

  Specified by:
    `isRunning` in interface `Lifecycle`
  Returns:
    whether the component is currently running
  See Also:
    `TimerManager.isSuspending()`, `TimerManager.isStopping()`

### destroy

    public void destroy()

  Cancels all statically registered Timers on shutdown, and stops the underlying TimerManager (if not shared).

  Specified by:
    `destroy` in interface `DisposableBean`
  See Also:
    `Timer.cancel()`, `TimerManager.stop()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.